
#include <LiquidCrystal.h>
#include <string.h>
const int rs = 12, en = 11, d4 = 5, d5 = 4, d6 = 3, d7 = 2;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

#define THINKTIME 100
#define BTN_PRSSD B00000001
#define BTN_HLDNG B00000010
#define BTN_RLSED B00000100

#define isButton(state) !!(button & state)
#define isButton2(state) !!(button2 & state)

byte buttonPin = 7;
byte buttonPin2 = 13;
byte button = BTN_HLDNG; // -1 released , 0 - pressed, 1 - buffered
byte button2 = BTN_HLDNG; // -1 released , 0 - pressed, 1 - buffered
unsigned long nextthink = 0;

byte car_hero1[] = {
  B10100,
  B11110,
  B10100,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000
};
byte car_hero2[] = {
  B00000,
  B00000,
  B00000,
  B01010,
  B01111,
  B01010,
  B00000,
  B00000
};
byte car_hero3[] = {
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B10100,
  B11110
};
byte car_hero12[] = {
  B10100,
  B11110,
  B10100,
  B01010,
  B01111,
  B01010,
  B00000,
  B00000
};

byte car_hero23[] = {
  B00000,
  B00000,
  B00000,
  B01010,
  B01111,
  B01010,
  B10100,
  B11110
};


byte car_hero13[] = {
  B10100,
  B11110,
  B10100,
  B00000,
  B00000,
  B00000,
  B10100,
  B11110
};

byte car_hero123[] = {
  B10100,
  B11110,
  B10100,
  B01010,
  B01111,
  B01010,
  B10100,
  B11110
};
byte heart[] = {
  B00000,
  B00000,
  B01010,
  B11111,
  B11111,
  B01110,
  B00100,
  B00000
};
byte lane = 0;

byte road_left[16];
byte road_right[16];

#define ROAD_LENGTH 16

void load_glyset00() {
  lcd.createChar(0, car_hero1);
  lcd.createChar(1, car_hero2);
  lcd.createChar(2, car_hero3);
  lcd.createChar(3, car_hero12);
  lcd.createChar(4, car_hero23);
  lcd.createChar(5, car_hero13);
  lcd.createChar(6, car_hero123);
  lcd.createChar(7, heart);
}

int glyset = 0;

void setup() {
  memset(road_left, 0, sizeof(byte) * ROAD_LENGTH);
  memset(road_right, 0, sizeof(byte) * ROAD_LENGTH);
  lcd.begin(ROAD_LENGTH, 2);
  load_glyset00();
  lcd.home();
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Destroy the Cars!");
  lcd.setCursor(1,1);
  lcd.print("Button: Start");
}



#define EMPTY_GLY 32
#define EMPTY_GLY_NEO 255
#define GAME_BLOCK_GLY 255
#define GAME_PICKUP_GLY 165
#define GAME_SPEEDUP_GLY 126
#define GAME_BOOM_GLY 42
#define GAME_ALLCARSGOBOOM_GLY 239

#define CARS_R B1
#define CARS_M B10
#define CARS_L B100
#define GAME_SPEEDUP B1000
#define GAME_PICKUP B10000
#define GAME_BLOCK B100000
#define GAME_BOOM B1000000
#define GAME_ALLCARSGOBOOM B10000000

#define CAR_PLAYER 3

unsigned int frames = 0;

bool check(byte ch, byte state) {
  return (ch & state) == state;
}

int game_state = -1;
int score = 0;
int speeduptime = 0;
int scoretime = 0;
int combo = 0;
int moneytime = 0;
int money = 3;

void allcarsgoboom() {
  int c = 0;
  byte cell;
  for (int i = 0; i < ROAD_LENGTH; i++) {
    cell = road_left[i];
    if (check(cell, CARS_R | CARS_M | CARS_L)) {
      c += 3;
      road_left[i] = GAME_BOOM;
    } else if (check(cell, CARS_L | CARS_M)) {
      c += 2;
      road_left[i] = GAME_BOOM;
    } else if (check(cell, CARS_R | CARS_M)) {
      c += 2;
      road_left[i] = GAME_BOOM;
    } else if (check(cell, CARS_R | CARS_L)) {
      c += 2;
      road_left[i] = GAME_BOOM;
    } else if (check(cell, CARS_L)) {
      c += 1;
      road_left[i] = GAME_BOOM;
    } else if (check(cell, CARS_M)) {
      c += 1;
      road_left[i] = GAME_BOOM;
    } else if (check(cell, CARS_R)) {
      c += 1;
      road_left[i] = GAME_BOOM;
    }
  }
  for (int i = 0; i < ROAD_LENGTH; i++) {
    cell = road_right[i];
    if (check(cell, CARS_R | CARS_M | CARS_L)) {
      c += 3;
      road_right[i] = GAME_BOOM;
    } else if (check(cell, CARS_L | CARS_M)) {
      c += 2;
      road_right[i] = GAME_BOOM;
    } else if (check(cell, CARS_R | CARS_M)) {
      c += 2;
      road_right[i] = GAME_BOOM;
    } else if (check(cell, CARS_R | CARS_L)) {
      c += 2;
      road_right[i] = GAME_BOOM;
    } else if (check(cell, CARS_L)) {
      c += 1;
      road_right[i] = GAME_BOOM;
    } else if (check(cell, CARS_M)) {
      c += 1;
      road_right[i] = GAME_BOOM;
    } else if (check(cell, CARS_R)) {
      c += 1;
      road_right[i] = GAME_BOOM;
    }
  }
  score+=c;
  if (scoretime > 0) {
    combo+=c;
  } else {
    combo = c;
  }
  scoretime = 25;
  money += c;
  moneytime = 15;
  
}
void death_message() {
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Destroyed:");
    lcd.print(score);
    lcd.print("cars");
    lcd.setCursor(1,1);
    lcd.print("Button: Restart?");  
    memset(road_left, 0, sizeof(byte) * ROAD_LENGTH);
    memset(road_right, 0, sizeof(byte) * ROAD_LENGTH);
}
void carcrash() {
  byte cell = 0;
  if ((lane / 3) == 0) {
    if (lane % 3 == 0) cell = CARS_L;
    else if (lane % 3 == 1) cell = CARS_M;
    else cell = CARS_R;
    if (road_left[CAR_PLAYER] == GAME_SPEEDUP) {
      speeduptime = 150;
      road_left[CAR_PLAYER] = 0;
    } else if (road_left[CAR_PLAYER] == GAME_ALLCARSGOBOOM) {
      allcarsgoboom();
      digitalWrite(8, HIGH);
      road_left[CAR_PLAYER] = 0;
    } else if (check(road_left[CAR_PLAYER], cell)) {
      score++;
      digitalWrite(8, HIGH);
      if (scoretime > 0) {
        combo++;
      } else {
        combo = 1;
      }
      scoretime = 25;
      if (speeduptime > 0) {
        money += 1;
        moneytime = 15;
        road_left[CAR_PLAYER] = EMPTY_GLY_NEO;
      } else {
        money-=2;
        moneytime = 15;
        road_left[CAR_PLAYER] = GAME_BOOM;
        if (money < 1) {
          game_state = 1;
          death_message();
          return;
        }
      }
    } else {
        digitalWrite(8, LOW);
    }
  }
  if ((lane / 3) == 1) {
    if (lane % 3 == 0) cell = CARS_L;
    else if (lane % 3 == 1) cell = CARS_M;
    else cell = CARS_R;

    if (road_right[CAR_PLAYER] == GAME_SPEEDUP) {
      speeduptime = 150;
      road_right[CAR_PLAYER] = 0;
    } else if (road_right[CAR_PLAYER] == GAME_ALLCARSGOBOOM) {
      digitalWrite(8, HIGH);
      allcarsgoboom();
      road_right[CAR_PLAYER] = 0;
    } else if (check(road_right[CAR_PLAYER], cell)) {
      digitalWrite(8, HIGH);
      score++;
      if (scoretime > 0) {
        combo++;
      } else {
        combo = 1;
      }
      scoretime = 25;
      if (speeduptime > 0) {
        money += 1;
        moneytime = 15;
        road_right[CAR_PLAYER] = EMPTY_GLY_NEO;
      } else {
        money-=2;
        moneytime = 15;
        road_right[CAR_PLAYER] = GAME_BOOM;
        if (money < 1) {
          game_state = 1;
          death_message();
          return;
        }
      }
    } else {
      digitalWrite(8, LOW);
    }
  }
}
void game() {
  if (isButton(BTN_PRSSD) && !isButton(BTN_HLDNG) && (game_state == -1 || game_state == 1)) {
    game_state = 0;
    speeduptime = 0;
    score = 0;
    scoretime = 0;
    moneytime = 0;
    money = 3;
  }
  if (isButton(BTN_PRSSD) && !isButton(BTN_HLDNG) && isButton2(BTN_PRSSD) && !isButton2(BTN_HLDNG)) {
    if (money > 11 && speeduptime == 0) {
      money -= 10;
      speeduptime = 150;
      moneytime = 15;
    }
    moneytime = 15;
  } else if (isButton(BTN_PRSSD)) {
    lane = (lane + 1) % 6;
  } else if (isButton2(BTN_PRSSD)) {
    lane = (6 + lane - 1) % 6;
  }
  if (game_state == -1 || game_state == 1)  return;
  lcd.setCursor(0,0);
  for (byte i = 0; i < ROAD_LENGTH; i++) {
      byte cell = road_left[i];
      if (i == CAR_PLAYER && (lane / 3) == 0) {
        if (lane % 3 == 0) cell |= CARS_L;
        else if (lane % 3 == 1) cell |= CARS_M;
        else cell |= CARS_R;
      }
      
      if (check(cell, GAME_BOOM)) {
        lcd.write(GAME_BOOM_GLY);
      } else if (check(cell, CARS_R | CARS_M | CARS_L)) {
        lcd.write((byte)6);
      } else if (check(cell, CARS_L | CARS_M)) {
        lcd.write((byte)3);
      } else if (check(cell, CARS_R | CARS_M)) {
        lcd.write((byte)4);
      } else if (check(cell, CARS_R | CARS_L)) {
        lcd.write((byte)5);
      } else if (check(cell, CARS_L)) {
        lcd.write((byte)0);
      } else if (check(cell, CARS_M)) {
        lcd.write((byte)1);
      } else if (check(cell, CARS_R)) {
        lcd.write((byte)2);
      } else if (check(cell, GAME_SPEEDUP)) {
        lcd.write(GAME_SPEEDUP_GLY);
      } else if (check(cell, GAME_ALLCARSGOBOOM)) {
        lcd.write(GAME_ALLCARSGOBOOM_GLY);
      } else {
        lcd.write(EMPTY_GLY);
      }
  }
  lcd.setCursor(0,1);
  for (byte i = 0; i < ROAD_LENGTH; i++) {
      byte cell = road_right[i];
      if (i == CAR_PLAYER && (lane / 3) == 1) {
        if (lane % 3 == 0) cell |= CARS_L;
        else if (lane % 3 == 1) cell |= CARS_M;
        else cell |= CARS_R;
      }
      
      if (check(cell, GAME_BOOM)) {
        lcd.write(GAME_BOOM_GLY);
      } else if (check(cell, CARS_R | CARS_M | CARS_L)) {
        lcd.write((byte)6);
      } else if (check(cell, CARS_L | CARS_M)) {
        lcd.write((byte)3);
      } else if (check(cell, CARS_R | CARS_M)) {
        lcd.write((byte)4);
      } else if (check(cell, CARS_R | CARS_L)) {
        lcd.write((byte)5);
      } else if (check(cell, CARS_L)) {
        lcd.write((byte)0);
      } else if (check(cell, CARS_M)) {
        lcd.write((byte)1);
      } else if (check(cell, CARS_R)) {
        lcd.write((byte)2);
      } else if (check(cell, GAME_SPEEDUP)) {
        lcd.write(GAME_SPEEDUP_GLY);
      } else if (check(cell, GAME_ALLCARSGOBOOM)) {
        lcd.write(GAME_ALLCARSGOBOOM_GLY);
      } else {
        lcd.write(EMPTY_GLY);
      }
  }
  if (scoretime > 0) {
    lcd.setCursor(0,0);
    lcd.print("+");
    lcd.print(combo);
    scoretime--;
  }
  if (moneytime > 0) {
    lcd.setCursor(13,0);
    lcd.print(money);
    lcd.print("$");
    moneytime--;
  }
  if (speeduptime > 0) {
    lcd.setCursor(13,1);
    lcd.print(speeduptime);
    speeduptime--;
  }

  if (speeduptime == 0) {
    if (frames % 4 != 0) return;
  } else {
    if (frames % 3 != 0) return;
  }
  
  for (byte i = 0; i < ROAD_LENGTH - 1; i++) {
    road_left[i] = road_left[i + 1];
    road_right[i] = road_right[i + 1];
  }
  int gen = random(1, 200);
  if (gen < 2) {
    road_left[ROAD_LENGTH - 1] = CARS_R | CARS_M | CARS_L;
  } else if (gen < 5) {
    road_left[ROAD_LENGTH - 1] = CARS_M | CARS_L;
  } else if (gen < 8) {
    road_left[ROAD_LENGTH - 1] = CARS_R | CARS_M;
  } else if (gen < 11) {
    road_left[ROAD_LENGTH - 1] = CARS_R | CARS_L;
  } else if (gen < 16) {
    road_left[ROAD_LENGTH - 1] = CARS_L;
  } else if (gen < 21) {
    road_left[ROAD_LENGTH - 1] = CARS_M;
  } else if (gen < 26) {
    road_left[ROAD_LENGTH - 1] = CARS_R;
  } else if (gen < 29) {
    road_left[ROAD_LENGTH - 1] = GAME_SPEEDUP;
  } else if (gen < 30) {
    road_left[ROAD_LENGTH - 1] = GAME_ALLCARSGOBOOM;
  } else {
    road_left[ROAD_LENGTH - 1] = 0;
  }
  gen = random(1, 200);
  if (gen < 2) {
    road_right[ROAD_LENGTH - 1] = CARS_R | CARS_M | CARS_L;
  } else if (gen < 5) {
    road_right[ROAD_LENGTH - 1] = CARS_M | CARS_L;
  } else if (gen < 8) {
    road_right[ROAD_LENGTH - 1] = CARS_R | CARS_M;
  } else if (gen < 11) {
    road_right[ROAD_LENGTH - 1] = CARS_R | CARS_L;
  } else if (gen < 16) {
    road_right[ROAD_LENGTH - 1] = CARS_L;
  } else if (gen < 21) {
    road_right[ROAD_LENGTH - 1] = CARS_M;
  } else if (gen < 26) {
    road_right[ROAD_LENGTH - 1] = CARS_R;
  } else if (gen < 29) {
    road_right[ROAD_LENGTH - 1] = GAME_SPEEDUP;
  } else if (gen < 30) {
    road_right[ROAD_LENGTH - 1] = GAME_ALLCARSGOBOOM;
  } else {
    road_right[ROAD_LENGTH - 1] = 0;
  }
  carcrash();
}
void loop() {

  if (!isButton(BTN_PRSSD) && isButton(BTN_HLDNG) && digitalRead(buttonPin) == HIGH) {
      button = BTN_PRSSD;
  }
  if (!isButton2(BTN_PRSSD) && isButton2(BTN_HLDNG) && digitalRead(buttonPin2) == HIGH) {
      button2 = BTN_PRSSD;
  }
  if (nextthink < millis()) {
    game();
    nextthink += THINKTIME;
    frames++;
    if (isButton(BTN_PRSSD | BTN_RLSED)) button |= BTN_HLDNG;
    if (isButton2(BTN_PRSSD | BTN_RLSED)) button2 |= BTN_HLDNG;
  }

  if (isButton(BTN_HLDNG) && !isButton(BTN_RLSED) && digitalRead(buttonPin) == LOW){
    button = BTN_RLSED;
  }
  if (isButton2(BTN_HLDNG) && !isButton2(BTN_RLSED) && digitalRead(buttonPin2) == LOW){
    button2 = BTN_RLSED;
  }
}
